<?php
/**
 * <h1>Quinsonnas Mail Checker</h1>
 * @author Sumit Dutta
 * @version 1.55 2007-02-15
 */

/* PEAR Classes Used */
require_once 'Archive/Tar.php';
require_once 'HTML/QuickForm.php';
require_once 'HTML/QuickForm/textarea.php';
require_once 'HTML/Table.php';
require_once 'Mail.php';
require_once 'Mail/RFC822.php';
require_once 'Mail/mime.php';
require_once 'Mail/mimeDecode.php';
// Never lay your eyes on this: require_once 'NET/IMAP.php';
// Never lay your eyes on this: require_once 'NET/POP3.php';

/* Quinsonnas Options/Classes */
require_once 'options.php';
// Make protocols and headers lowercase
$op['default_out_protocol'] = strtolower($op['default_out_protocol']);
$op['default_in_protocol'] = strtolower($op['default_in_protocol']);
for ($i = 0; $i < count($op['show_headers']); $i ++) {
   $op['show_headers'][$i] = strtolower($op['show_headers'][$i]);
}
// Globalizes the option variable
$option_keys = array_keys($op);
foreach ($option_keys as $option) {
   $GLOBALS['op'][$option] = $op[$option];
}
if (version_compare(phpversion(), '5.0') < 0) {
   require_once 'q_auth-php4.php';
}
else {
   require_once 'q_auth.php';
}

/* HTTP Header Information */
// Only one session allowed, started with Auth

$title = "Quinsonnas Mail Checker";

if (basename($_SERVER['PHP_SELF']) == 'header.php') return;

/* Form-submitted Variables */

$optional = false; // Login form not to be displayed by default

if (isset($_POST['username']) && isset($_POST['password']) && $op['local_server']) {
   // session_start(); // Not needed; done automatically
   $optional = false; // Login form not to be displayed
   $username = $_POST['username'];
   $password = $_POST['password'];
   $in_host = $op['default_local_hostname'];
   $in_protocol = $op['default_in_protocol'];
   $out_host = $op['default_local_smtp_hostname'];
   $out_protocol = $op['default_out_protocol'];
   $domain = $op['default_local_domain'];
}
else if (!$op['local_server'] && isset($_POST['in_protocol']) && isset($_POST['in_host']) && isset($_POST['out_protocol']) && isset($_POST['out_host'])) {
   $optional = false; // Login form not to be displayed
   $username = $_POST['username'];
   $password = $_POST['password'];
   $in_host = $_POST['in_host'];
   $in_protocol = $_POST['in_protocol'];
   $out_host = $_POST['out_host'];
   $out_protocol = $_POST['out_protocol'];
   $domain = $op['default_remote_domain'];
}
else {
   if ($op['default_access']) {
      $optional = false; // Login form not to be displayed
      $username = $op['default_username'];
      $password = $op['default_password'];
   }
   else {
      $optional = true; // Login form to be displayed
   }
   $in_host = $op['default_remote_hostname'];
   $in_protocol = $op['default_in_protocol'];
   $out_host = $op['default_remote_smtp_hostname'];
   $out_protocol = $op['default_out_protocol'];
   $domain = $op['default_remote_domain'];
}
if ($op['local_server']) {
   $in_host = $op['default_local_hostname'];
   $in_protocol = $op['default_in_protocol'];
   $out_host = $op['default_local_smtp_hostname'];
   $out_protocol = $op['default_out_protocol'];
   $domain = $op['default_local_domain'];
}

/* Parse Host and Port */

// Incoming
if (strpos($in_host, ':') === false) {
   $in_hostname = $in_host;
   $in_port = $op['default_port'][$op['default_in_protocol']];
}
else {
   $in_hostname = substr($in_host, 0, strpos($in_host, ':'));
   $in_port = substr($in_host, strpos($in_host, ':') + 1);
}

// Outgoing
if (strpos($out_host, ':') === false) {
   $out_hostname = $out_host;
   $out_port = $op['default_port'][$op['default_out_protocol']];
}
else {
   $out_hostname = substr($out_host, 0, strpos($out_host, ':'));
   $out_port = substr($out_host, strpos($out_host, ':') + 1);
}

/* Login form */
$form = new HTML_QuickForm('loginForm', 'post', basename($_SERVER['PHP_SELF']));

$form->setDefaults(array());
$form->removeAttribute('name');

$form->addElement('header', null, 'Mail Server Login');

if (!$op['local_server']) {
   $form->addElement('radio', 'in_protocol', 'Incoming Protocol:', 'imap', 'IMAP');
   $form->addElement('radio', 'in_protocol', null, 'pop', 'POP');
   $form->addElement('text', 'in_host', 'Incoming Host:', array('size' => 80, 'maxlength' => 512));
   $form->addElement('radio', 'out_protocol', 'Outgoing Protocol:', 'mail', 'Mail');
   $form->addElement('radio', 'out_protocol', null, 'sendmail', 'Sendmail');
   $form->addElement('radio', 'out_protocol', null, 'smtp', 'SMTP');
   $form->addElement('text', 'out_host', 'SMTP Host (if SMTP chosen):', array('size' => 80, 'maxlength' => 512));
   $form->addElement('text', 'domain', 'Domain Name (y.com in x@y.com):', array('size' => 80, 'maxlength' => 512));
   
   $form->addRule('in_protocol', 'Please enter an incoming protocol', 'required', null, 'client');
   $form->addRule('out_protocol', 'Please enter an outgoing protocol', 'required', null, 'client');
   $form->addRule('in_host', 'Please enter an incoming host', 'required', null, 'client');
   // $form->addRule('out_host', 'Please enter an outgoing host', 'required', null, 'client');
   $form->addRule('domain', 'Please enter a domain name', 'required', null, 'client');
}

$form->addElement('text', 'username', 'Username: ', array('size' => 30, 'maxlength' => 255, 'id' => 'username'));
$form->addElement('password', 'password', 'Password: ', array('size' => 30, 'maxlength' => 255));
$form->addElement('submit', null, 'Login');

$form->applyFilter('username', 'trim');
$form->applyFilter('password', 'trim');

$form->addRule('username', 'Please enter a username', 'required', null, 'client');
$form->addRule('password', 'Please enter a password', 'required', null, 'client');

$form_addendum = '';
if ($op['local_server']) {
   $form_addendum .= "<p>Since this mail client is configured for use with the local server, ";
   $form_addendum .= "it cannot be used to access other hosts or this host on different ";
   $form_addendum .= "ports.</p>";
}
else {
   $portPOP = $op['default_port']['pop'];
   $portIMAP = $op['default_port']['imap'];
   $portSMTP = $op['default_port']['smtp'];
   
   $form_addendum .= <<<IFREMOTECONNALLOWED
   <p>To specify the port to connect to for each host (incoming
      and/or outgoing), simply place the port number after the hostname
   followed by a colon, as would be done in a uniform resource locator (URL).
   The port does not have to be specified, since the default value is used
   if not specified. Some example hostnames are <span
   style="font-style: italic;">localhost</span>, <span
   style="font-style: italic;">localhost:$portPOP</span>
   (default for local POP), <span style="font-style: italic;">localhost:$portIMAP</span>
   (default for local IMAP), <span style="font-style: italic;">localhost:$portSMTP</span>
   (default for local SMTP), <span style="font-style: italic;">pop.gmail.com</span>,
   
   or <span style="font-style: italic;"><span
   style="font-style: italic;"><span
   style="font-style: italic;">smtp.gmail.com:25</span></span></span>.</p>
IFREMOTECONNALLOWED;
}

/* Authentication */

$q_auth_params = array('in_hostname' => $in_hostname, 'in_port' => $in_port, 'in_protocol' => $in_protocol, 'out_hostname' => $out_hostname, 'out_port' => $out_port, 'out_protocol' => $out_protocol, 'domain' => $domain);
$q_auth =& new Quinsonnas_Auth($q_auth_params);
// $auth = &new Auth('POP3', "$in_hostname:$in_port", 'loginFunction', $optional);
$auth =& new Auth($q_auth, $q_auth_params, 'loginFunction', $optional);
$auth->setSessionname('Quinsonnas');

/**
 * Login function
 */
function loginFunction() {
   global $form, $form_addendum;
   
   require_once 'head.php';
   bigTree();
   $form->display();
   
   echo $form_addendum;
   echo "<p>Those servers with";
   echo " differing ports are allowed but not encouraged to be used with this";
   echo " due to the possibility of having to access a secure server (not yet supported).</p>";
   echo "<p><span style=\"font-weight: bold;\">Cookies are required</span> to login.</p>";
}

$auth->start();

if ($auth->checkAuth()) { // same as getAuth()
   require_once 'head.php';
   if (isset($_GET['action']) && $_GET['action'] == 'logout' && basename($_SERVER['PHP_SELF']) == 'index.php') {
      $auth->logout();
      ?>
      <p>You are currently <span style="font-weight: bold;">logged out</span>.
      Thanks for using Quinsonnas!</p>
      <?php
      $auth->start(); // Shows form
   }
   else {
      flowTree();
      echo "<p>You are authenticated. <a href=\"index.php?action=logout\">Please logout</a> when finished.</p>";
   }
}
else {
   require_once 'head.php';
   if (!empty($auth->status) && $auth->status == AUTH_EXPIRED) {
      $status = 'Your session has expired. Please login again!'."\n";
   } else if (!empty($auth->status) && $auth->status == AUTH_IDLED) {
      $status = 'You have been idle for too long. Please login again!'."\n";
   } else if (!empty ($auth->status) && $auth->status == AUTH_WRONG_LOGIN) {
      $status = 'Wrong login data!'."\n";
   } else if (!empty ($auth->status) && $auth->status == AUTH_SECURITY_BREACH) {
      $status = 'Security problem detected. '."\n";
   }
   if (isset($status)) {
      echo "<p style=\"color: rgb(255, 0, 0); font-weight: bold;\">$status</p>";
   }
   echo "<p>You are currently not logged in. <a href=\"?action=login\">Please login</a>.</p>";
}
?>

