<?php
/**
 * <h1>Quinsonnas Mail Checker</h1>
 * @author Sumit Dutta
 * @version 1.55 2007-02-15
 */

/* Database Connection Options */
// Quinsonnas database: quinsonnas (unchanging)
$op['db_hostname'] = 'localhost';
$op['db_password'] = '2s24p10d'; // db_username = quinsonnas (cannot change)

/* Options File for Administrator */

// Use local mail server and save messages and login information
// on local server
// Warning: It is advised that both values be both true or both false
// so database space is not unnecessarily wasted
$op['save_mail'] = true; // 'true' causes all mail to be saved on the
                              // local server
                              // 'false' means users can only read and send
                              // mail; but it will not be stored on this
                              // local server
$op['local_server'] = true; // 'false' allows users to connect to
                                  // mailboxes on other servers;
                                  // the default being that server
                                  // specified in $op['default_server']
                                  // 'true' allows only connection to
                                  // 'localhost'
$op['show_headers'] = array('from','to','cc','date','subject'); // valid ones only

/* Defaults */

// Domain (y.com in x@y.com)
$op['default_local_domain'] = 'southriverhigh.org';
$op['default_remote_domain'] = 'gmail.com';

// For reading mail
$op['default_local_hostname'] = 'southriverhigh.org'; // usually 'localhost'
$op['default_remote_hostname'] = 'pop.gmail.com';
$op['default_in_protocol'] = "pop"; // use "pop", "imap", or (not yet: something supported by c-client IMAP functions)
$op['default_remote_folder'] = 'INBOX'; // set to '' for none, usually is 'INBOX'

// For sending mail
$op['default_out_protocol'] = "sendmail"; // only one supported, use "mail", "smtp", or "sendmail"
$op['default_from_override'] = true; // for "mail" and "sendmail": whether to override the "From:" header using arguments to sendmail with the user's information
// Mail-specific
$op['default_mail_params'] = null; // can be set to what would be the fifth parameter for the mail() function for sending mail
// Sendmail-specific
$op['default_sendmail_path'] = null; // can be set to path to sendmail (i.e. /usr/bin/sendmail is default)
$op['default_sendmail_args'] = "-i"; // can be set to sendmail arguments (default is "-i", which would result in the execution of "sendmail -i")
// SMTP-specific
$op['default_smtp_auth'] = true; // whether user must be authenticated to use SMTP (default is false)
$op['default_smtp_auth_override'] = false; // whether the 'default_smtp_auth' option previously specified overrides user preference
$op['default_local_smtp_hostname'] = 'smtp.southriverhigh.org';
$op['default_remote_smtp_hostname'] = 'smtp.gmail.com';

// Following 3 should correspond to local server's port if applicable
$op['default_port']['pop'] = 110;
$op['default_port']['imap'] = 143;
$op['default_port']['smtp'] = 25;
$op['default_port']['sendmail'] = 0;
$op['default_port']['mail'] = 0;

// Allow access by default
$op['default_access'] = false;
$op['default_username'] = 'anonymous';
$op['default_password'] = 'anonymous';

// Use gethostbyname() to increase speed
// Requires that hostnames are not subdomains
$op['in_hostip'] = true;
$op['out_hostip'] = false;

// Server administrator contact
$op['admin_email'] = 'southriv@southriverhigh.org';

// Maximum incoming/outgoing email size (limit on message header
// and limit on message body, but not combined);
// this means all incoming attachments + the message body < $op['email_size']
// in multibyte characters
$op['email_size'] = 2 * pow(2, 20); // 2 MB
$op['email_attachments'] = 2; // message composer:
                              // number of attachment prompts to show
$op['email_attachment_size'] = 1 * pow(2, 20); // 1 MB, largest size an outgoing attachment can be

// HTML tags not to allow in viewed email
$op['html_remove'] = array('script', 'applet', 'object');

/* Custom header parts and footer */

// Specify what else you would like in the header and footer
// (a value of '' means that more contents are not needed)
// (to be used with "require" statements)
// (the include path is the same as the default, but the directory this file is in comes first,
// so you can make a path relative to this directory)
$op['header_head'] = 'head-customize.php'; // filename for what else goes in <head> section
$op['header_body'] = 'header-customize.php'; // filename for what else goes in beginning <body> section
$op['footer_body'] = 'footer-customize.php'; // filename for end of the <body> section (should contain no </body></html>)

/* Custom index page (add a FAQ or similar info) */
// Make sure to treat apostrophes (') as (\')
$op['index_description'] = '
<h2>Frequently Asked Questions</h2>
<p style="font-weight: bold;">What is Quinsonnas Mail?</p>
<p>Quinsonnas Mail is a web-based email client for those with 
reserved accounts on this server. Assured under the GPL, it 
is an attempt to revolutionize webmail access in a secure, 
non-commercial manner.</p>
<p style="font-weight: bold;">What is meant by the name?</p>
<p>As most well-read students should gather, Quinsonnas alludes to 
<span style="text-decoration: underline;">Paris in the 20th 
Century</span>, in which an artist and his companion Quinsonnas struggle 
to maintain culture in an overly technical world. The musician 
Quinsonnas is solely a reminder of the importance of balancing culture 
in fine arts and technology.</p>
<p style="font-weight: bold;">Why should I check email here when I can 
use Yahoo or some other mega email provider?</p>
<p>Your question could answer this per se, but more specifically: 
Quinsonnas offers email access for <span 
style="font-weight: bold;">all team leaders</span>, and <span 
style="font-weight: bold;">all emails and contacts are shared</span>. 
You also get a professional address 
<code><span style="font-style: italic;">yourteam</span>@southriverhigh.org</code> 
you can use with dignity and without shame when writing to officials and leaders of various institutions.</p>
<p style="font-weight: bold;">Cool; we want an email at SouthRiverHigh.org!</p>
<p>Space for email accounts is <span style="font-weight: bold;">limited</span>. Only the student organizations of the school with sufficient involvement with 
students, teachers, parents, and officials in the school, 
government, or other relevant institution are eligible for an email 
account.</p>
<p style="font-weight: bold;">Can you describe the criteria for getting an email account?</p>
<p>The straightforward answer is "no," since it is already very rare 
that we hand out email accounts. However, the more appropriate 
answer is for you to <a href="http://www.southriverhigh.org/contact/webmailform.php?email=2">try 
your rhetoric</a> with the web development team advisor, Mrs. Champagne.</p>
';

?>
