<?php
/**
 * <h1>Quinsonnas Mail Checker</h1>
 * @author Sumit Dutta
 * @version 1.55 2007-02-15
 */

require_once 'Auth.php';
require_once 'Auth/Container.php';
// require_once 'Auth/Container/IMAP.php';
// require_once 'Auth/Container/POP3.php';
// require_once 'Net/IMAP.php';
// require_once 'Net/POP3.php';

require_once 'options.php';

class Quinsonnas_Auth extends Auth_Container {
   var $username;
   var $password;
   var $in_hostname;
   var $in_port;
   var $in_protocol;
   var $out_hostname;
   var $out_port;
   var $out_protocol;
   
   var $domain;
   
   /**
    * User ID in database
    */
   var $uid;
   var $fullname;
   
   /**
    * Maildrop used by this instance
    */
   var $flag;
   var $maildrop;
   var $folder;
   var $imap_open_params;
   
   /**
    * MySQL Connection
    */
   var $link;
   var $result;
   
   /**
    * Quinsonnas_Auth
    * @param array in_hostname, in_port, in_protocol, out_hostname, out_port, out_protocol
    * @return a constructed Quinsonnas_Auth container
    */
   function Quinsonnas_Auth($params) {
      // $this->username = $params[0];
      // $password = $params[1];
      if ($GLOBALS['op']['in_hostip']) {
         $this->in_hostname = gethostbyname($params['in_hostname']);
      }
      else {
         $this->in_hostname = $params['in_hostname'];
      }
      $this->in_port = $params['in_port'];
      $this->in_protocol = $params['in_protocol'];
      if ($GLOBALS['op']['out_hostip']) {
         $this->out_hostname = gethostbyname($params['out_hostname']);
      }
      else {
         $this->out_hostname = $params['out_hostname'];
      }
      $this->out_port = $params['out_port'];
      $this->out_protocol = $params['out_protocol'];
      
      $this->domain = $params['domain'];
      
      $this->flag = '';
      
      switch (strtolower($this->in_protocol)) {
      case 'imap':
         // $this->flag = '/imap';
         break;
      default: // case 'pop'
         $this->flag = '/pop3';
         break;
      }
      // print_r($params);
      // echo "($this->in_hostname $this->out_hostname)";
      // echo 'CONSTRUCTED';
   }
   
   function createUserUnlessThere($username) {
      /* Connect to database */
      
      $this->link = mysql_connect($GLOBALS['op']['db_hostname'], 'quinsonnas', $GLOBALS['op']['db_password']);
      mysql_select_db('quinsonnas');
      $this->result = mysql_query('SELECT uid, username, fullname, in_hostname, in_port, in_protocol, out_hostname, out_port, out_protocol, domain FROM user');
      
      // Verify if entry matches given user, else create new
      $i = 0;
      while ($user = mysql_fetch_array($this->result, MYSQL_ASSOC)) {
         $table_uid[$i] = $user['uid'];
         $table_username[$i] = $user['username'];
         $table_fullname[$i] = $user['fullname'];
         $table_in_hostname[$i] = $user['in_hostname'];
         $table_in_port[$i] = $user['in_port'];
         $table_in_protocol[$i] = $user['in_protocol'];
         $table_out_hostname[$i] = $user['out_hostname'];
         $table_out_port[$i] = $user['out_port'];
         $table_out_protocol[$i] = $user['out_protocol'];
         $i ++;
      }
      mysql_free_result($this->result);
      
      $i = 0;
      $found_match = false;
      for ($i = 0; isset($table_uid) && $i < count($table_uid); $i ++) {
         // Username
         if ($username != $table_username[$i]) {
            continue;
         }
         // In_hostname
         if ($this->in_hostname != $table_in_hostname[$i]) {
            continue;
         }
         // In_port
         if ($this->in_port != $table_in_port[$i]) {
            continue;
         }
         // In_protocol
         if ($this->in_protocol != $table_in_protocol[$i]) {
            continue;
         }
         // Out_hostname
         if ($this->out_hostname != $table_out_hostname[$i]) {
            continue;
         }
         // Out_port
         if ($this->out_port != $table_out_port[$i]) {
            continue;
         }
         // Out_protocol
         if ($this->out_protocol != $table_out_protocol[$i]) {
            continue;
         }
         
         $this->uid = $table_uid[$i];
         $this->fullname = $table_fullname[$i];
         
         $found_match = true;
         break;
      }
      
      if (!$found_match) {
         if (!isset($table_uid)) {
            // && count($table_uid) == 0) {
            $this->uid = 0;
         }
         else {
            $this->uid = $table_uid[count($table_uid) - 1] + 1;
         }
         $this->fullname = strtoupper(substr($username, 0, 1)).substr($username, 1);
         
         $query = 'INSERT INTO user (`uid`, `username`, `fullname`, `in_hostname`, `in_port`, `in_protocol`, `out_hostname`, `out_port`, `out_protocol`, `domain`) VALUES (';
         $query .= $this->uid.',\''.$username.'\',\''.$this->fullname;
         $query .= '\',\''.$this->in_hostname.'\','.$this->in_port.',\''.$this->in_protocol;
         $query .= '\',\''.$this->out_hostname.'\','.$this->out_port.',\''.$this->out_protocol;
         $query .= '\',\''.$this->domain.'\'';
         $query .= ')';
         mysql_query($query);
         
         $query = 'INSERT INTO options (uid, mail_list_size) VALUES ('.$this->uid.', 20)';
         mysql_query($query);
         
         $query = "CREATE TABLE ".$this->uid."_mail (
            `id` int(11) NOT NULL,
            `folder` varchar(60) NOT NULL,
            `headers` text NOT NULL,
            `body` mediumtext NOT NULL,
            `attach` text NOT NULL,
            `read` tinyint(1) NOT NULL default '0',
            `flagged` tinyint(1) NOT NULL default '0'
         )";
         mysql_query($query);
         
         $query = "CREATE TABLE ".$this->uid."_addr (
            `id` int(11) NOT NULL,
            `name1` varchar(60) NOT NULL,
            `name2` varchar(60) NOT NULL,
            `email` varchar(128) NOT NULL,
            `nickname` varchar(60) NOT NULL,
            `phone1` varchar(30) NOT NULL,
            `phone2` varchar(30) NOT NULL,
            `phone3` varchar(30) NOT NULL,
            `phone4` varchar(30) NOT NULL,
            `phone5` varchar(30) NOT NULL,
            `address` text NOT NULL,
            `schedule` text NOT NULL,
            `role` varchar(60) NOT NULL,
            `custom1` text NOT NULL,
            `custom2` text NOT NULL,
            `custom3` text NOT NULL,
            `custom4` text NOT NULL
         )";
         mysql_query($query);
         
         // $query = "INSERT INTO ".$this->uid."_addr () VALUES ()";
         // mysql_query($query);
         
         $query = "CREATE TABLE ".$this->uid."_list (
            `id` int(11) NOT NULL,
            `id_list` text NOT NULL,
            `name` text NOT NULL
         )";
         mysql_query($query);
      }
      
      /* Don't close yet: mysql_close(); */
      return;
   }
   
   function downloadMessages() {
      /* Connect to database */
      
      /* Already connected
      $this->link = mysql_connect($GLOBALS['op']['db_hostname'], 'quinsonnas', $GLOBALS['op']['db_password']);
      mysql_select_db('quinsonnas');
      */
      
      /* Determined user's UID; now use table for it */
      $uid_mail_table = $this->uid.'_mail';
      
      /* Debugging */
      
/*
?>
<pre>
Getmailboxes:
<?php
print_r(imap_getmailboxes($this->maildrop, $this->imap_open_params[0], '*'));
?>
</pre>
<pre>
Errors:
<?php
print_r(imap_errors());
?>
</pre>
<pre>
Headers:
<?php
print_r(imap_headers($this->maildrop));
?>
</pre>
<?php
*/

      /* Download and insert into database */
      
      $msg_total = imap_num_msg($this->maildrop);
      
      for ($msg_counter = 1; $msg_counter <= $msg_total; $msg_counter ++) {
         $header = '';
         $body = '';
         $attach = '';
         
         // echo "<p>Processing message $msg_counter</p>";
         
         // Enforce size limits on incoming email
         // use strlen, not mb_strlen
         
         if (strlen(imap_fetchheader($this->maildrop, $msg_counter)) < $GLOBALS['op']['email_size']) {
            $header = imap_fetchheader($this->maildrop, $msg_counter);
         }
         
         if (strlen(imap_body($this->maildrop, $msg_counter)) < $GLOBALS['op']['email_size']) {
            $body = imap_body($this->maildrop, $msg_counter);
         }
         
         // Determine message ID
         
         $this->result = mysql_query("SELECT `id` FROM $uid_mail_table");
         $last_id = -1;
         while ($id = mysql_fetch_array($this->result, MYSQL_ASSOC)) {
            $last_id = $id['id'] + 0;
         }
         $message_id = $last_id + 1;
         
         // Extract and save attachments
         
         $message = $header.$body;
         
         $params['include_bodies'] = true;
         $params['decode_bodies'] = true;
         $params['decode_headers'] = true;
         $params['input'] = $message;
         
         $structure = Mail_mimeDecode::decode($params);
         
         $inbox = true;
         if (strpos($structure->headers['from'], $this->fullname) !== false) {
            $inbox = false;
         }
         $message_folder = $inbox?'Inbox':'Sent';
         
         $any_attachments_there = false;
         $attach_no = 0;
         if (isset($structure->parts) && is_array($structure->parts)) {
            foreach ($structure->parts as $part) {
               // if (isset($part->disposition) && $part->disposition == 'attachment') {
               if (isset($part->ctype_primary) && $part->ctype_primary != 'text') {
                  $any_attachments_there = true;
                  $attach_no ++;
               }
            }
         }
         
         if ($any_attachments_there) {
            $attach = $attach_no.'';
         }
         else {
            $attach = '';
         }
         
         /* Save attachments to disk separately */
         /* (not yet proven to work) */
         /*
         if ($any_attachments_there) {
            $attach = $this->uid.'_'.$message_id.'.tar.bz2';
            $archive = new Archive_Tar($attach, 'bz2');
            
            foreach ($structure->parts as $part) {
               if (isset($part->disposition) && $part->disposition == 'attachment') {
                  $fn = $part->ctype_parameters['filename'];
                  /*
                  if ($part->ctype_primary == 'text') {
                     continue;
                  }
                  *
                  $archive->addString($fn, $part->body);
                  /*
                  $file = fopen($fn, 'w');
                  fwrite($file, $part->body);
                  fclose($file);
                  *
               }
            }
            /* close $archive (at end of script?) *
         }
         else {
            $attach = '';
         }
         *
         
         /* Extract that attachment part from the body *
         if ($structure->ctype_primary == 'multipart') {
            $message_bodyparts = explode($structure->ctype_parameters['boundary'], $body);
            $body = '';
            foreach ($message_bodyparts as $bodypart) {
               if (strpos($bodypart, 'Content-Disposition: attachment') === false) {
                  $body .= $bodypart;
                  if (strpos($bodypart, 'Content-Type: ') !== false) {
                     $body .= $structure->ctype_parameters['boundary'];
                  }
               }
            }
         }
         */
         
         // echo '<pre>'.$body.'</pre>';
         
         /* Compress body */
         /* Format: DEFLATE Compressed Data Format Specification version 1.3 */
         // $body = gzdeflate($body, 4);
         
         /* SQL Query modifier */
         /* Used ' in query to enter text */
         $header = Quinsonnas_Auth::sqlString($header);
         $body = Quinsonnas_Auth::sqlString($body);
         $attach = Quinsonnas_Auth::sqlString($attach);
         
         mysql_query("INSERT INTO $uid_mail_table (`id`, `folder`, `headers`, `body`, `attach`) VALUES ($message_id, '$message_folder', '$header', '$body', '$attach')");
         
         imap_delete($this->maildrop, $msg_counter);
      }
      
      imap_expunge($this->maildrop);
      mysql_close($this->link);
   }
   
   function fetchData($username, $password) {
      $this->imap_open_params = array(0 => '{'.$this->in_hostname.':'.$this->in_port.$this->flag.'}'.$GLOBALS['op']['default_remote_folder'], 1 => $username, 2 => $password);
      $this->maildrop = imap_open($this->imap_open_params[0], $this->imap_open_params[1], $this->imap_open_params[2]);
      if ($this->maildrop != false) {
         /* Only one folder allowed on POP3 server */
         
         $this->folder = imap_list($this->maildrop, '{'.$this->in_hostname.':'.$this->in_port.$this->flag.'}', "*");
         if ($this->folder == false) {
            echo "<p>The <b>call for folders failed</b>. Please log in and try again or report the problem to the server administrator at ".Quinsonnas_Auth::emailLink($GLOBALS['op']['admin_email']).".</p>";
         }
         $this->uid = -1; // not yet known, but true
         $this->createUserUnlessThere($username);
         $this->downloadMessages();
         return true;
      }
      imap_close($this->maildrop);
      return false;
   }
   
   function emailLink($email) {
      $elink = str_replace(array('@', '.'), array("' + '@' + '", "' + '.' + '"), $email);
      $etext = str_replace(array('@', '.'), array(' at ', ' dot '), $email);
      $emod = <<<DUPONTMARKETSQUARECIRCLE
<script type="text/javascript">
//<![CDATA[
   document.write('<a href="mailto:' + '$elink' + '">');
//]]>
</script>$etext<script type="text/javascript">
//<![CDATA[
   document.write('</a>');
//]]>
</script>
DUPONTMARKETSQUARECIRCLE;
      return $emod;
   }
   
   function sizeShorten($size) {
      if ($size > 1024) {
         $size /= 1024;
         if ($size > 1024) {
            $size /= 1024;
            if ($size > 1024) {
               $size /= 1024;
               if ($size > 1024) {
                  $size /= 1024;
                  if ($size > 1024) {
                     $size /= 1024;
                     $size = round($size, 3);
                     $size .= 'Pb';
                  }
                  else {
                     $size = round($size, 3);
                     $size .= 'Tb';
                  }
               }
               else {
                  $size = round($size, 3);
                  $size .= 'Gb';
               }
            }
            else {
               $size = round($size, 3);
               $size .= 'Mb';
            }
         }
         else {
            $size = round($size, 3);
            $size .= 'kb';
         }
      }
      else {
         $size = round($size, 3);
         $size .= 'b';
      }
      return $size;
   }
   /**
    * Makes an SQL syntax string (in '') out of a messy email string
    */
   function sqlString($original_string) {
      // This always first!
      $search[] = "\\";
      $replace[] = "\\\\";
      // Then the others
      $search[] = "\n";
      $replace[] = '\n';
      $search[] = "\r";
      $replace[] = '\r';
      $search[] = "'";
      $replace[] = "\'";
      $search[] = "\"";
      $replace[] = '\"';
      $search[] = "\t";
      $replace[] = '\t';
      // $search[] = "%";
      // $replace[] = '\%';
      // $search[] = "_";
      // $replace[] = '\_';
      return str_replace($search, $replace, $original_string);
   }
   
   /* Accessors do not work from other classes
   function imapOpenParams() {
      return $this->imap_open_params; // array with 3 indices
   }
   
   function inHostname() {
      return $this->in_hostname;
   }
   */
}
?>
